# 前言

通过使用几个`设计模型`的思想，我们设计一款五子棋游戏。更好地对`设计模式`进行理解。注意，本次的设计并不包含任何的游戏引擎，完全使用`Flutter`自带的包进行设计。

在目前主流的五子棋游戏中，常有的行为有：棋子、棋盘、玩家的状态（是否可以悔棋）、以及悔棋的记录。

因此，我们这次的五子棋设计打算采用6种设计模式，分别是`享元模式`、`单例模式`、`桥接模式`、`工厂方法`、`状态模式`、`备忘录模式`。

# 内容

我们将主要的讲解内容放到了掘金网站。具体看下面的：

* [Flutter从头到尾设计一款简单的五子棋游戏(一) | 设计模式构思](https://juejin.cn/post/7173961682627559431)
* [Flutter从头到尾设计一款简单的五子棋游戏(二) | 构思与代码](https://juejin.cn/post/7175522152178221111)
* [Flutter从头到尾设计一款简单的五子棋游戏(三) | 具体代码设计](https://juejin.cn/post/7176111304745156665)
* [Flutter从头到尾设计一款简单的五子棋游戏(四) | 设计模式代码完结](https://juejin.cn/post/7177351477629812796)
* [Flutter从头到尾设计一款简单的五子棋游戏(五) | UI代码](https://juejin.cn/post/7179611086872641597)

有任何的问题欢迎提issue。

# 结语

由于这份代码已经是2022年初的东西了，那会写Flutter还不是很规范，因此会有挺多的问题。欢迎大家提出指证，或者提pull request。